using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for PNNClassification.
	/// </summary>
	public class PNNClassification : System.Windows.Forms.Form
	{
		int							N;				//number features/components in each feature vector
		int							K;				//number initial clusters to start clustering
		int							K1;				//Read, but never used!
		int							J;				//number components in label vectors
		int							R;			//No. feature vectors to be tested
		int							i,m,n,r;								
		int							checkit1,checkit2,checkit3;
		double						dist;			
		
		int							TotalVectors;				//after training, the total examplar numbers of each cluster (k)
		double						SumError1,SumError2,MSE,SSE;      
		double					    sigma;		
		public static double[]					fuzzybelief       = new double[1000]; 
	
		public static double[,]					newvector		 = new double[250000,50];		//test data	
		public static double[,]				  	v				 = new double[1000,50];    //v[i][n] = component n of cluster k center	
		public static double[]					p                = new double[250000];
		
		char						NewLine			= (char)13;
		char						Return			= (char)10;
		
		string						inFile1,inFile2;				//names of input data files
		string						outFile;
		
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.OpenFileDialog openFileDialog2;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.TextBox textBox4;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		public PNNClassification()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PNNClassification));
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.button3 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.button4 = new System.Windows.Forms.Button();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.button6 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button1 = new System.Windows.Forms.Button();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.groupBox3.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox3
			// 
			this.groupBox3.BackColor = System.Drawing.Color.Transparent;
			this.groupBox3.Controls.Add(this.button3);
			this.groupBox3.Controls.Add(this.textBox1);
			this.groupBox3.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox3.Location = new System.Drawing.Point(40, 112);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(288, 64);
			this.groupBox3.TabIndex = 26;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Step 2: Input Training Result File !";
			this.groupBox3.Enter += new System.EventHandler(this.groupBox3_Enter);
			// 
			// button3
			// 
			this.button3.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button3.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button3.ForeColor = System.Drawing.Color.Black;
			this.button3.Location = new System.Drawing.Point(192, 24);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(80, 23);
			this.button3.TabIndex = 1;
			this.button3.Text = "Load File";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 24);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(160, 22);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			// 
			// groupBox4
			// 
			this.groupBox4.BackColor = System.Drawing.Color.Transparent;
			this.groupBox4.Controls.Add(this.button4);
			this.groupBox4.Controls.Add(this.textBox3);
			this.groupBox4.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox4.ForeColor = System.Drawing.Color.SeaShell;
			this.groupBox4.Location = new System.Drawing.Point(40, 272);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(288, 64);
			this.groupBox4.TabIndex = 23;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Step 4: Select Path and Name for Output File !";
			// 
			// button4
			// 
			this.button4.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button4.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button4.ForeColor = System.Drawing.Color.SeaShell;
			this.button4.Location = new System.Drawing.Point(192, 24);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(80, 23);
			this.button4.TabIndex = 1;
			this.button4.Text = "Save As";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// textBox3
			// 
			this.textBox3.Location = new System.Drawing.Point(16, 24);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(160, 22);
			this.textBox3.TabIndex = 0;
			this.textBox3.Text = "";
			// 
			// groupBox2
			// 
			this.groupBox2.BackColor = System.Drawing.Color.Transparent;
			this.groupBox2.Controls.Add(this.button2);
			this.groupBox2.Controls.Add(this.textBox2);
			this.groupBox2.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox2.Location = new System.Drawing.Point(40, 192);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(288, 64);
			this.groupBox2.TabIndex = 22;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Step 3: Input Data File for Classification !";
			this.groupBox2.Enter += new System.EventHandler(this.groupBox2_Enter);
			// 
			// button2
			// 
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button2.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.ForeColor = System.Drawing.Color.Black;
			this.button2.Location = new System.Drawing.Point(192, 24);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(80, 23);
			this.button2.TabIndex = 1;
			this.button2.Text = "Load File";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(16, 24);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(160, 22);
			this.textBox2.TabIndex = 0;
			this.textBox2.Text = "";
			this.textBox2.TextChanged += new System.EventHandler(this.textBox2_TextChanged);
			// 
			// groupBox5
			// 
			this.groupBox5.BackColor = System.Drawing.Color.Transparent;
			this.groupBox5.Controls.Add(this.button6);
			this.groupBox5.Controls.Add(this.button5);
			this.groupBox5.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox5.ForeColor = System.Drawing.Color.SeaShell;
			this.groupBox5.Location = new System.Drawing.Point(40, 352);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(288, 64);
			this.groupBox5.TabIndex = 24;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Step 5: Apply Probabilistic Neural Network !";
			// 
			// button6
			// 
			this.button6.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button6.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button6.ForeColor = System.Drawing.Color.SeaShell;
			this.button6.Location = new System.Drawing.Point(160, 24);
			this.button6.Name = "button6";
			this.button6.TabIndex = 1;
			this.button6.Text = "Return";
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// button5
			// 
			this.button5.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button5.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button5.ForeColor = System.Drawing.Color.SeaShell;
			this.button5.Location = new System.Drawing.Point(48, 24);
			this.button5.Name = "button5";
			this.button5.TabIndex = 0;
			this.button5.Text = "Run";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.BackColor = System.Drawing.Color.Transparent;
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox1.Location = new System.Drawing.Point(40, 32);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(288, 64);
			this.groupBox1.TabIndex = 21;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Step 1: Read Instruction Before Processing Data!";
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(96, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Instructions";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// textBox4
			// 
			this.textBox4.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.textBox4.Font = new System.Drawing.Font("Times New Roman", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox4.Location = new System.Drawing.Point(356, 40);
			this.textBox4.MaxLength = 32676;
			this.textBox4.Multiline = true;
			this.textBox4.Name = "textBox4";
			this.textBox4.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox4.Size = new System.Drawing.Size(408, 376);
			this.textBox4.TabIndex = 25;
			this.textBox4.Text = "";
			this.textBox4.TextChanged += new System.EventHandler(this.textBox4_TextChanged);
			// 
			// PNNClassification
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(800, 478);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.textBox4);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.groupBox5);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.groupBox2);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Name = "PNNClassification";
			this.Text = "PNN Classification";
			this.groupBox3.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void button3_Click(object sender, System.EventArgs e)
		{
			string intText;
		
			openFileDialog1.Filter = "prb Files (*.prb)|*.prb|All files (*.*)|*.*" ;
						

			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{					
				textBox1.Text = openFileDialog1.FileName;
				inFile1 = openFileDialog1.FileName;
				//define stream buffer and open file for reading 
				FileStream inStream = new FileStream(inFile1,FileMode.Open, 
					FileAccess.Read,FileShare.None);
				//define a variable for reading stream to
				StreamReader reader = new StreamReader(inStream, Encoding.ASCII);

				//start at beginning of input file again
				inStream.Seek(0,SeekOrigin.Begin);
				
				//read single string value: each is on a different file line
				//convert each string into an integer				
				
				intText = reader.ReadLine();
				N = int.Parse(intText);	
							
				intText = reader.ReadLine();
				sigma = double.Parse(intText);	
				
				intText = reader.ReadLine();
				TotalVectors = int.Parse(intText);

				for (i=0;i<TotalVectors;i++)
				{						
					for (n=0;n<N;n++)
					{
						intText = reader.ReadLine();
						v[i,n] = double.Parse(intText);							
					}

				}	

				for (i=0;i<TotalVectors;i++)
				{						
					
					intText = reader.ReadLine();
					fuzzybelief[i] = double.Parse(intText);	
				}	
				
			
								
				this.textBox4.AppendText(" Training result file has been read successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText("" + textBox1.Text + NewLine + Return+NewLine + Return);
				
				this.textBox4.AppendText(" Please go to step 3! " + NewLine + Return);
				
				reader.Close();
				inStream.Close();

				checkit1 =1;
			}

			else checkit1 =0;		
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			textBox4.Clear();
			saveFileDialog1.Filter = "pnn Files (*.pnn)|*.pnn|All files (*.*)|*.*" ;
			
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				textBox3.Text = saveFileDialog1.FileName;
				outFile = saveFileDialog1.FileName;

				this.textBox4.AppendText("The Result of the probability function valure for each vector will be saved in the following file : "+ NewLine+Return + NewLine + Return);
				this.textBox4.AppendText(""+ textBox3.Text + NewLine + Return+NewLine + Return);
				this.textBox4.AppendText("Please click Run button! "+ NewLine+Return);

				checkit3 =1;
				
			}

			else checkit3 =0;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			openFileDialog2.Filter = "dta Files (*.dta)|*.dta|All files (*.*)|*.*" ;

			textBox4.Clear();

			if(openFileDialog2.ShowDialog() == DialogResult.OK)
			{					
				textBox2.Text = openFileDialog2.FileName;
				inFile2 = openFileDialog2.FileName;							
				
				this.textBox4.AppendText(" Data file has been read successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText("" + textBox2.Text + NewLine + Return+NewLine + Return);
				this.textBox4.AppendText(" Please go to step 4! " + NewLine + Return);
								
				checkit2=1;
			}
			
			else checkit2 =0;
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			string intText2;
			double minGoodness = 9999.99;
			double maxGoodness = 0;	
			double maxfuzzyfunction;
			

			double[]  fuzzyfunction = new double [250000];
		
			textBox4.Clear();	
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);	
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);	

			if ((checkit1 ==1)&&(checkit2==1)&&(checkit3==1))
			{
				
				textBox4.Clear();
				this.textBox4.AppendText(" The program is running, please wait..." + NewLine + Return);
				
			//--------after click RUN Button, program start running ------//					
				
				//define stream buffer and open file for reading 
				FileStream inStream = new FileStream(inFile2,FileMode.Open, 
					FileAccess.Read,FileShare.None);				
				
				//define a variable for reading stream to
				StreamReader reader = new StreamReader(inStream, Encoding.ASCII);

				//start at beginning of input file again
				inStream.Seek(0,SeekOrigin.Begin);
				
				//read single string value: each is on a different file line
				//convert each string into an integer			
				
				intText2 = reader.ReadLine();
				N = int.Parse(intText2);	
								
				intText2 = reader.ReadLine();
				K1 = int.Parse(intText2);
				
				intText2 = reader.ReadLine();
				J = int.Parse(intText2);
				
				intText2 = reader.ReadLine();
				R = int.Parse(intText2);	
							
				string [] strArray;			
				char[] charArray = new char[] {','};	
							
						
				for (r = 0; r < R; r++)
				{
					intText2 = reader.ReadLine();
					strArray = intText2.Split(charArray);
					//-----------demonstrate the input data----------------				
					//---------------------begin to read data--------------
					
					n=0;

					for (m = 3;m<strArray.Length-1;m++)
					{									
						//temp[r,m] = Convert.ToDouble(strArray[m]);	
						
						newvector[r,n] = Convert.ToDouble(strArray[m]);
					   
						//newvector[r,n] = temp[r,m];
										
						n++;					
					}					
				
					//*****************************************************************/
					//---------------PNN Calculation Function-----------------------
	
					//double part = 0.0f;
					double denu = 0.0f;
					//double sum=0.0f;				
										
					//part = Math.Sqrt(Math.Pow(2*Math.PI,N))*Math.Pow(sigma,N);
					denu = 2*Math.Pow(sigma,2);
					
					maxfuzzyfunction = 0.0;	
	
					for (i=0;i<TotalVectors;i++)
					{
						dist = 0;
						
						for (n=0;n<N;n++)
						{
							dist = dist+ Math.Pow((newvector[r,n]-v[i,n]),2);
						}

						fuzzyfunction[i]  = fuzzybelief[i] * Math.Exp(-dist/denu);

						if (fuzzyfunction[i] >maxfuzzyfunction)
						{
							maxfuzzyfunction = fuzzyfunction[i] ;				//to get the max.probability for each vector
							
						}
						//sum = sum + fuzzybelief[i] * Math.Exp(-dist/denu);			
					}

					p[r] = maxfuzzyfunction;
						
					//p[r]=(1.0f/part)*(1.0f/TotalVectors)*sum;
					//p[r]=1.0f/TotalVectors * sum;										
																				
					
				}	// end of loop of for (r = 0; r < R; r++)
				//*****************************************************************/
				//---------------------------save the result to the output file----------------------			
				// get name of selected output file
				
				FileStream outStream = new FileStream(outFile,FileMode.OpenOrCreate);

				// define writer to write stream to output file
				//StreamWriter writer = new StreamWriter(outStream,Encoding.ASCII);
				StreamWriter writer = new StreamWriter(outStream);
	
				outStream.Seek(0,SeekOrigin.Begin);
								
				//writer.Write(" " + "Vector No." + " " + "Cluster No." + "    " + "Fit to Cluster 1"+ "    " + "Fit to Cluster 2" + NewLine + Return);
				
				//writer.Write("---------------------------------------------------------------" + NewLine + Return);
				SumError1 = 0;
				SumError2 = 0;
				SSE = 0;
												
				for (r=0;r<R;r++)
				{   
					writer.Write("" + Convert.ToString(r+1));
					
									
					writer.Write("," + Convert.ToString(1));						
						
					
					if (p[r]< minGoodness)

					{
						minGoodness = p[r];
					}

					if (p[r] > maxGoodness)
					{
					
						maxGoodness = p[r];
					}					

					if (p[r] > 0.5)
					{
						SumError1 = SumError1 + Math.Pow((p[r] - 1),2);
					}

					else
					{
						SumError2 = SumError2 + Math.Pow(p[r],2);
					}

					SSE = SumError1 + SumError2;

					MSE = (SumError1+SumError2)/R;

					writer.Write("," + Convert.ToString(String.Format("{0:0.0000}" , (p[r]))));
					writer.Write("" + NewLine + Return);							
											  		  		  
				}

				textBox4.Clear();
				
				this.textBox4.AppendText(" The classification is done successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText(" Please go to " + textBox3.Text + " to check out the classification results" + NewLine + Return);
				this.textBox4.AppendText(" ----------------------------------------------------------"+NewLine + Return);
				this.textBox4.AppendText(" PNN Classification Overall-Measures: " + NewLine + Return);					
				
				this.textBox4.AppendText(" Minimum Fit to Class : " + Convert.ToString(String.Format("{0:0.0000}" , minGoodness)) + NewLine + Return);
				this.textBox4.AppendText(" Maximum Fit to Class : " + Convert.ToString(String.Format("{0:0.0000}" , maxGoodness)) + NewLine + Return);
				this.textBox4.AppendText(" MSE = " + Convert.ToString(String.Format("{0:0.0000}" , MSE)) + NewLine + Return);
				this.textBox4.AppendText(" SSE = " + Convert.ToString(String.Format("{0:0.0000}" , SSE)) + NewLine + Return + NewLine + Return);

				this.textBox4.AppendText("The classification results are being written to the file, please wait..." + NewLine + Return);
				
				
				reader.Close();
				inStream.Close();
			 
				//---------------End PNN Calculation Function---------------------      
				//*****************************************************************/
								
			    writer.Flush();  

				// close output stream
				writer.Close();
				outStream.Close();	
		
				
			
				PNNResult dlg1 = new PNNResult();
				dlg1.ShowDialog();

			}

			else
				MessageBox.Show(" Please input valid files before running !" );


				


		}

		private void textBox2_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox2_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			PNNClassificationInstruction dlg = new PNNClassificationInstruction();
			dlg.ShowDialog();
		}

		private void groupBox3_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void textBox4_TextChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
