using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for PNNTrainingResult.
	/// </summary>
	public class PNNTrainingResult : System.Windows.Forms.Form
	{
		int i,n,q,k;
		
		char			NewLine				= (char)13;
		char			Return				= (char)10;	
		
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label6;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public PNNTrainingResult()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			textBox1.Clear();
			
			this.textBox1.AppendText(Convert.ToString(PNN.N)+ NewLine + Return);
			this.textBox1.AppendText(Convert.ToString(Math.Round(PNN.sigma,2)) + NewLine + Return);
			this.textBox1.AppendText(Convert.ToString(PNN.TotalVectors) + NewLine + Return);
			
			for (i=0;i<PNN.TotalVectors;i++)
			{						
				for (n=0;n<PNN.N;n++)
				{
					this.textBox1.AppendText(Convert.ToString(PNN.v[i,n]) + NewLine + Return);
				}

			}	
			
	
			for(i=0;i<PNN.TotalVectors;i++)
		
			{
				this.textBox1.AppendText(Convert.ToString(PNN.fuzzyValue[i]) + NewLine + Return);
			
			}

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PNNTrainingResult));
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.label6 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(32, 48);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(56, 24);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			this.textBox1.Visible = false;
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// button1
			// 
			this.button1.BackColor = System.Drawing.Color.Transparent;
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(104, 48);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(72, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "Return";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label6
			// 
			this.label6.BackColor = System.Drawing.Color.Transparent;
			this.label6.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.ForeColor = System.Drawing.Color.Black;
			this.label6.Location = new System.Drawing.Point(24, 16);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(237, 23);
			this.label6.TabIndex = 17;
			this.label6.Text = " The PNN training results have been saved !";
			// 
			// PNNTrainingResult
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(280, 110);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.textBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "PNNTrainingResult";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "PNN Training Results";
			this.ResumeLayout(false);

		}
		#endregion

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//*****************************************************************/
			//---------------------------save the result to the output file----------------------			
			// get name of selected output file
				
			FileStream outStream = new FileStream(PNN.outFile,FileMode.OpenOrCreate);

			// define writer to write stream to output file
			//StreamWriter writer = new StreamWriter(outStream,Encoding.ASCII);
			StreamWriter writer = new StreamWriter(outStream);
			
			string inText = this.textBox1.Text;
			outStream.Seek(0,SeekOrigin.Begin);
			writer.Write(inText);
			writer.Flush(); 			

			// close output stream
			writer.Close();
			outStream.Close();	
		
			this.Close();

			System.GC.Collect();
		}
	}
}
