using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for RbflnTrainingResult.
	/// </summary>
	public class RbflnTrainingResult : System.Windows.Forms.Form
	{
		
		int k,i,j,m,n,q;
		
		public static double[,]		center				= new double[2000,200];
		public static double[,]     weightNJ			= new double[10,200];
		
		 
		char						NewLine		= (char)13;
		char						Return		= (char)10;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public RbflnTrainingResult()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			textBox1.Clear();	
			this.textBox1.AppendText(Convert.ToString(RbflnFunctions.N)+ NewLine + Return);
			this.textBox1.AppendText(Convert.ToString(RbflnM.M)+ NewLine + Return);
			this.textBox1.AppendText(Convert.ToString(RbflnFunctions.J) + NewLine + Return);
			this.textBox1.AppendText(Convert.ToString(RbflnFunctions.TotalVectors) + NewLine + Return);
			this.textBox1.AppendText(Convert.ToString(RbflnFunctions.Q) + NewLine + Return);
			this.textBox1.AppendText(Convert.ToString(Math.Round(RbflnFunctions.sig2,3)) + NewLine + Return);
			
			
			for (n=0;n<RbflnFunctions.N;n++)
			{
				for (m=0;m<RbflnFunctions.M;m++)
				{
					center[m,n]=RbflnFunctions.w[n,m];			
					
				}				
			}
			

			for ( m=0;m<RbflnM.M;m++)
			{
				for (n=0;n<RbflnFunctions.N;n++)
				{
					this.textBox1.AppendText( Convert.ToString(Math.Round(center[m,n],2))+ "	" );
				}
					this.textBox1.AppendText("" + NewLine + Return);
			}
			
			for ( m=0;m<RbflnM.M;m++)
			{
				for ( j=0;j<RbflnFunctions.J;j++)
				{
					this.textBox1.AppendText( Convert.ToString(Math.Round(RbflnFunctions.u[m,j],4))+ "	" );
				}
				this.textBox1.AppendText("" + NewLine + Return);
			}
			
			for (n=0;n<RbflnFunctions.N;n++)
			{
				for (j=0;j<RbflnFunctions.J;j++)
				{
					weightNJ[j,n]=RbflnFunctions.v[n,j];				
					
				}				
			}

			for ( j=0;j<RbflnFunctions.J;j++)
			{
				for (n=0;n<RbflnFunctions.N;n++)
				{
					this.textBox1.AppendText( Convert.ToString(Math.Round(weightNJ[j,n],4))+ "	" );
				}
				this.textBox1.AppendText("" + NewLine + Return);
			}

			for(j=0;j<RbflnFunctions.J;j++)
		
			{
				this.textBox1.AppendText(Convert.ToString(Math.Round(RbflnFunctions.b[j],4)) + NewLine + Return);
			
			}

		
		
				//this.textBox1.AppendText(Convert.ToString(RbflnFunctions.TotalVectors)+ NewLine + Return);
						
			

			
		
				//for (i=0;i<RbflnFunctions.TotalVectors;i++)
				//{
					//this.textBox1.AppendText( Convert.ToString(RbflnFunctions.vect[k,i])+ "	" );
				//}
				//this.textBox1.AppendText("" + NewLine + Return);
		

			for ( q = 0; q < RbflnFunctions.Q;q++)
			{

				for (j=0;j<RbflnFunctions.J;j++)
				{				
					this.textBox1.AppendText(Convert.ToString( RbflnFunctions.t[j,q]) + "	");	
				}
				this.textBox1.AppendText("" + NewLine + Return);
			}		

		}		

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(RbflnTrainingResult));
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.textBox1.Font = new System.Drawing.Font("Times New Roman", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(16, 64);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(48, 32);
			this.textBox1.TabIndex = 5;
			this.textBox1.Text = "";
			this.textBox1.Visible = false;
			// 
			// label6
			// 
			this.label6.BackColor = System.Drawing.Color.Transparent;
			this.label6.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.ForeColor = System.Drawing.Color.Black;
			this.label6.Location = new System.Drawing.Point(13, 32);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(259, 23);
			this.label6.TabIndex = 16;
			this.label6.Text = " The RBFLN training results have been saved !";
			// 
			// button1
			// 
			this.button1.BackColor = System.Drawing.Color.Transparent;
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(144, 64);
			this.button1.Name = "button1";
			this.button1.TabIndex = 17;
			this.button1.Text = "Return";
			this.button1.Click += new System.EventHandler(this.button1_Click_1);
			// 
			// RbflnTrainingResult
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(322, 128);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.textBox1);
			this.Font = new System.Drawing.Font("Times New Roman", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "RbflnTrainingResult";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Rbfln Training Result";
			this.Load += new System.EventHandler(this.RbflnTrainingResult_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{					
		
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button1_Click_1(object sender, System.EventArgs e)
		{			
			//*****************************************************************/
			//---------------------------save the result to the output file----------------------			
			// get name of selected output file
				
			FileStream outStream = new FileStream(TrainRBFLN.outFile,FileMode.OpenOrCreate);

			// define writer to write stream to output file
			//StreamWriter writer = new StreamWriter(outStream,Encoding.ASCII);
			StreamWriter writer = new StreamWriter(outStream);
			
			string inText = this.textBox1.Text;
			outStream.Seek(0,SeekOrigin.Begin);
			writer.Write(inText);
			writer.Flush(); 			

			// close output stream
			writer.Close();
			outStream.Close();			

			this.Close();
		}

		private void RbflnTrainingResult_Load(object sender, System.EventArgs e)
		{
		
		}
	}
}
