using System;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for FuzzyFunctions.
	/// </summary>
	public class FuzzyFunctions
	{
		public static int			N;								//number features/components in each feature vector
		public static int			K;								//number initial clusters to start clustering
		public static int			J;								//number components in label vectors
		public static int			Q;								//number of feature vectors in data file
		public static double		s;								//proportion for setting merge threshold
		public static double        sig;
		public static int[]			count		= new int[1000];		//count[k] = no. vectors in class k
		public static int			localits;						//no. iterations given by user for a run
		public static int			totalits;						//total no. iterations so far
		public static int			minp;							//eliminate clusters of minp or fewer vectors 
		public static double[]		fuzzytruth  = new double[1000];
		  
		public static double[,]		x			= new double[1000,50];//input feature vectors
		public static double[,]		t			= new double[1000,50];//output labels for input feature vectors
		public static double[,]		v			= new double[1000,50];	 //center vectors for clusters
		public static double[]		clust		= new double[1000];//clstr[q] = k: x[q] in clstr k 
		
		public static double[]		sig2		= new double[500];  
		
		public static double		XB;				  //Xie-Beni clustering validity
		public static double        CVAL;
				

		public FuzzyFunctions()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		//--------------File Reading Function---------------------
		
		public static int  readfile()
		{
			
			int m,n,q,j;
			string intText1;
			
			
			if (FuzzyTrain.inFile == null)
			{ 
				return 0;
			}
			
			FileStream inStream = new FileStream(FuzzyTrain.inFile,FileMode.Open, 
				FileAccess.Read,FileShare.None);
			//define a variable for reading stream to
			StreamReader reader = new StreamReader(inStream, Encoding.ASCII);

			//start at beginning of input file again
			inStream.Seek(0,SeekOrigin.Begin);
				
			//read single string value: each is on a different file line
			//convert each string into an integer
																
			intText1 = reader.ReadLine();
			N = int.Parse(intText1);
			//this.textBox4.AppendText("N = " + intText1+ NewLine + Return);	

			intText1 = reader.ReadLine();
			K = int.Parse(intText1);
			//this.textBox4.AppendText("K = " + intText1+ NewLine + Return);	

			intText1 = reader.ReadLine();
			J = int.Parse(intText1);
				
			intText1 = reader.ReadLine();
			Q = int.Parse(intText1);	
			//this.textBox4.AppendText("Q = " + intText1+ NewLine + Return + NewLine + Return);	
			
			string [] strArray;			
			char[] charArray = new char[] {','};					
				
			for (q = 0; q < Q; q++)
			{
				intText1 = reader.ReadLine();
				strArray = intText1.Split(charArray);
				//-----------demonstrate the input data----------------
				//this.textBox4.AppendText(intText1+ NewLine + Return);	
				
				//---------------------begin to read data--------------				
				
				for (j=0;j<J;j++)
				{
					t[q,j]=Convert.ToDouble(strArray[1]);
						
				}
				
				n=0;
				
				for (m = 3;m<strArray.Length-1;m++)
				{									
					//temp[q,m] = Convert.ToDouble(strArray[m]);							
					   
					x[q,n] = Convert.ToDouble(strArray[m]);
					
					//x[q,n] = temp[q,m];
										
					n++;					
				}

				fuzzytruth[q]=Convert.ToDouble(strArray[strArray.Length-1]);

								
			} // end of "for q = 0;q<Q " loop
					
				
			//--------------------testing points individual paramter ------------------------------------
				
			//this.textBox4.AppendText(Convert.ToString(x[0,0])+ "	"+ NewLine+Return);
			//this.textBox4.AppendText(Convert.ToString(x[1,1])+ "	"+ NewLine+Return);
			//this.textBox4.AppendText(Convert.ToString(x[4,2])+ "	"+ NewLine+Return);
			//this.textBox4.AppendText(Convert.ToString(t[0,0])+ "	"+ NewLine+Return);
			//this.textBox4.AppendText(Convert.ToString(gain[15])+ "	"+ NewLine+Return);
			//this.textBox4.AppendText(Convert.ToString(consequentIndex[14]));
				
			reader.Close();
			inStream.Close();	
		
		    
			double xmax,xmin,xdiff;
			
			for (n=0;n<N;n++)
			{
				xmax = -999999.9; xmin = 999999.9;
				for (q=0;q<Q;q++)
				{
					if (x[q,n] > xmax) xmax = x[q,n];
					if (x[q,n] < xmin) xmin = x[q,n];
				}
				xdiff = xmax - xmin;
				for (q=0;q<Q;q++) x[q,n] = (x[q,n] - xmin)/xdiff;
			}
			
			return 1;
		}//------------------------End of Reading Function----------------------------
		//***************************************************************************
		//---------------K-means Clustering Function----------------------------------
		public static void kmeans()
		{
			int      k, kk, n;
			int      q, ii;						// kount;
			int      kmin = 0;
			int      KMEANITS = 12;
			double    dist;
			double    aveD, minD, maxSig;
			double    varAve, mse;
			double    []		aveVec	= new double[1000];

			
			for (ii=0;ii<KMEANITS;ii++)     //Do loops on k-means clustering
			{
				for (k=0;k<K;k++) count[k]=0; //Initialize cluster counts
				for (q=0;q<Q;q++)             //For each feature vector x(q) find min. dist. 
				{
					minD = 99999.0;             //of all distances to cluster centers
					for (k=0;k<K;k++) 
					{
						dist = 0;
						for (n=0;n<N;n++) dist = dist + Math.Pow((v[k,n] - x[q,n]),2);
						if (dist < minD)
						{
							minD = dist; 
							kmin = k;							
						}
						
					}                       
					clust[q] = kmin;		   //Assign vector to closest center
					count[kmin]++;		   //and increment count
				}
				//- - - - - - - - - - - - - Average Cluster Vectors - - - - --
				for (k=0;k<K;k++)         //For each kth cluster, if cluster k is
				{
					if (count[k] > 0)       //not empty, then zero out center
					{
						for (n=0;n<N;n++) v[k,n] = 0.0;
					}
					for (q=0;q<Q;q++)       //For each feature vector x(q), if it is
					{
						if (clust[q] == k)    //in cluster k, include it in averaging sum
						{
							for (n=0;n<N;n++) v[k,n] = v[k,n] + x[q,n];
						}
					}
					if (count[k] > 1)       //If cluster not empty, take average
					{
						for (n=0;n<N;n++) v[k,n] = v[k,n]/count[k];
					}
				}
			}                           //Done with k-means clustering
			//- - - - - - - - - - - - - - Compute Cluster Variances- - - - - -
			for (k=0;k<K;k++)           //For each kth cluster, if x(q)
			{
				sig = 0.0;
				for (q=0;q<Q;q++)         //belongs to it then include it
				{
					if (clust[q] == k)      //in mean-square error
					{
						for (n=0;n<N;n++) sig = sig + Math.Pow((v[k,n] - x[q,n]),2);
					}                       //(to compute variance) of cluster k
				}
				if (count[k] > 1)
				{
					sig2[k] = sig/count[k];
				}
				else        sig2[k] = 0.0;
			}
			/*----------Compute Validity Measures-----------------*/
			//XB = Xie-Beni clustering validity,  MXB = modified XB clustering validity
			//KW = Kwon clustering validity
			//NV1, NV2, NV3 = New Validity clustering validities
			aveD       = 0.0;  
			varAve     = 0.0;  
			mse        = 0.0;
			minD       = 999999.9;
			maxSig     = 0.0;
			//V        = (float)0.0;
			//Compute min. and ave. cluster intercenter distances
			for (k=0;k<K-1;k++)
			{ 
				for (kk=k+1;kk<K;kk++)
				{ 
					dist = 0.0; 
					for (n=0;n<N;n++) dist = dist + Math.Pow((v[k,n]-v[kk,n]),2);
					if (dist < minD)  minD = dist;
					aveD = aveD + dist;
				}
			}
			aveD = aveD / (K*(K-1)/2);

			//Compute average and maximum of cluster variances
			for (k=0;k<K;k++)
			{
				varAve = varAve + sig2[k];
				if(sig2[k] > maxSig) maxSig = sig2[k];
			}
			varAve = varAve/K;
   
			//Compute average feature vector over all input vectors
			for (n=0;n<N;n++)
			{
				aveVec[n] = 0.0;
				for (q=0;q<Q;q++)  aveVec[n] = aveVec[n] + x[q,n];
				aveVec[n] = aveVec[n]/Q;
			}
   
			//Compute MSE of cluster centers about feature vector average
			for (n=0;n<N;n++)
			{
				for (k=0;k<K;k++) mse = mse + Math.Pow((v[k,n] - aveVec[n]),2);
			}
			mse = mse/K;

			
			//Compute validity measures
			XB   = varAve/minD;
			CVAL = 1.0/XB;
			//MXB  = (float)(varAve/aveD); 
			//KW   = (float)((varAve + mse)/minD);
			//NV1  = (float)((varAve + mse)/aveD);
			//NV2  = (float)((varAve + mse)/(minD + aveD));
			//NV3  = (float)(maxSig/aveD);
			//NV4  = (float)(varAve + mse)/((float)0.76*minD + (float)0.24*aveD);
			//NV5  = (float)(maxSig/((float)0.76*minD + (float)0.24*aveD));
			//NV6  = (float)(maxSig/minD);
				 
			//empty = 'f';
			return;
		}//------------------------End of K-Means Function-----------------------------
		//******************************************************************************//	
		//-------------------------Initialize Clustering Function-----------------------
			public static void initialize()
			{
				int      k, n, kk;
				int      kkmin;
				char     doit;
				double   temp,D;
				double   dist, dmin, minD,root;

				D= 33768.0;

				temp = 12.0*(Math.Log10(Q)/Math.Log10(2))+1.0;

				K = 6*N + Convert.ToInt32(temp);

				Random R = new Random (DateTime.Now.Millisecond);

				if (K < Q) K = Q;	
					
				for (k=0;k<Q;k++)			//For each of Q input feature vectors
				{
					for (n=0;n<N;n++)		    //initialize each as a cluster seed vector
					{
						v[k,n] = x[k,n];
					}
					
					if (K > Q)
					{
						for (k=Q;k<K;k++)
						{
							for (n=0;n<N;n++)		    //initialize each as a cluster seed vector
							{
								v[k,n] = Convert.ToDouble(R.Next(33768))/D;
							}
						
						}
					}
					
					
				}										
					
				root = 1.0/N;
				dmin = 1.0/Math.Pow(Q, root); //Too close parameter
				doit = 't';
				//kount = 0; Eliminate clusters while doit is true
			 
				/*------------Find min distance between pairs-----------------*/
				kkmin = 0;
				do                          //Check min. distances between centers
				{
					minD = 99999.0;         //and eliminate a center if too close
					for (k=0;k<K-1;k++)     //For each unique pair of centers
					{
						for (kk=k+1;kk<K;kk++)//Find min. distance over all pairs
						{
							dist = 0.0;
							for (n=0;n<N;n++) dist = dist + Math.Pow((v[k,n] - v[kk,n]),2);
							if (dist < minD)
							{
								minD = dist;	//minD is min. distance squared
								kkmin = kk;
							}
						}
					}						//kkmin is index of second clstr cntr of pair with min. distance
   
					/*--------Eliminate prototype too close to other one--------*/
					minD = Math.Sqrt(minD);
					if (minD < dmin)          //If center pair is too close then
					{
						for (k=kkmin;k<K-1;k++) //delete latter center, close indices
						{
							for (n=0;n<N;n++) v[k,n] = v[k+1,n];
						}
						K--;
					}
					else   doit = 'f';        //Minimum distance: too large to delete
          
				} while (doit == 't');     //If min. dist. too small, stop loop
   
				//- - - - - - - - - - - - - - - - - -Print Centers- - - - - - --
				//this.textBox1.AppendText("After eliminations: ");
				//this.textBox1.AppendText(" K = " + Convert.ToString(K));
				//this.textBox1.AppendText("" + NewLine + Return + NewLine + Return);

				return;
			} //-------------------End Initialize Function-----------------------------
		//******************************************************************************/
		//-------------------------Elimps Function--------------------------------------
		
		public static void elimps()
		
		{	
			int   kk, n, q,  k, elimno = 0; 
			char  doit;

			//printf("- - - - - - ELIMINATE CLUSTERS WITH p OR FEWER ");
			//printf("FEATURE VECTORS- - - - - - - - -\n\n");
			 
			lbl4: k = 0; doit = 't';
			if (minp >= 0)		//if minp < 0 then set to 0, else get from user
			{ //printf("\n Enter no. p to eliminate clusters of size <= p: ? ");
				//scanf("%d", &minp);
				minp = 2;				//Enter no. p to eliminate clusters of size <= p
			}
			else     minp = 0;
			  
			do
			{ if (count[k] <= minp)        //if cluster k has <= p vectors
				{ elimno = elimno + count[k];
				for (kk=k;kk<K-1;kk++)     //move all higher clusters down by 1
				{ count[kk] = count[kk+1]; //move counts down by 1
					for (n=0;n<N;n++) v[kk,n] = v[kk+1,n]; //move prototypes down
					for (q=0;q<Q;q++)                        //move all vectors in
					{ if (clust[q] == kk+1) clust[q] = kk;   //class down a class
					}
				}
				K--;                       //Adjust K if a cluster is eliminated
				}
				k++;
				if (k >= K) doit = 'f';
			} while (doit == 't');
			  
			for (k=0;k<K;k++)
			{ if (count[k] <= minp)
				{ //printf(" Cluster elimination is continuing!\n"); 
				minp = -1;
				goto lbl4;
				}
			}			
			
			return;
		}//---------------------End of Elimps Function Function-------------------
		//************************************************************************/
		//----------------------Merge Clusters Function---------------------------		
		
		public static void merge()
		{			
			int    r, ii, n, k, kk, q, R, EIGHT = 8;//kount,
			int	[]	k1 = new int [250000]; 
			int []	k2 = new int [250000];
			double  ddave,D, d, tau; 
			double []	dd = new double [250000];
			double  sumd, variance, var, alfnk, sigwfev;

			R = K*(K-1)/2; ddave = 0.0;
			r = 0;                   //Set first unique pair with r=0
			for (k=0;k<K-1;k++)      //For cluster centers k and kk
			{
					for (kk=k+1;kk<K;kk++) //find distance sum D between centers
			  {
					  D = 0.0;
				  for (n=0;n<N;n++)
				  {	
					  D = D + Math.Pow(v[k,n] - v[kk,n],2);
				  }
				  D = Math.Sqrt(D);  ddave = ddave + D;
				  dd[r] = D;  
						
				  k1[r] = k;			//record pair indexed by pair counter  
				  k2[r] = kk;
				  r++;		//record distance, increment pair counter
			  }
			}
			ddave =  ddave/R; 
			variance = (float)(ddave/2.4);
			var = (float)2.0*variance*variance;

			//- - - - - - -Find fuzzy average of inter-center distances- - - - -
			for (ii=0;ii<EIGHT;ii++)    //8 iterations for WFEV of pair distances
			{
					D = 0.0; sumd = 0.0; 
				for (r=0;r<R;r++)      //For each rth unique pair of centers
				{
						d = Math.Pow(dd[r] - ddave,2); //get squared distance
					if (var > 0.0) alfnk = Math.Exp(-d/var); //and WFEV coefficients
					else           alfnk = 0.0;
					D        = D + alfnk;
					sumd     = sumd + alfnk*dd[r];
					variance = variance + alfnk*d;
				}
				if (D > 0.0)
				{
					ddave = sumd/D; variance = variance/D; var = 2*variance;
				}
				else
				{
					ddave = sumd; var = 2.0*variance;
				}
				sigwfev = Math.Sqrt(variance);
				
			}
			
			//- - - - - - - - - - -Merge- - - - - - - - - - - - - - - - --
			
			tau   =  ddave * FuzzyTrainingParameter.s; 
			
			//- - - - - - - - Merge close small clusters- - - - - - - - --
			for (r=0;r<R;r++)             //If rth pair is close enough to merge
			{
					if (dd[r] < tau)            //then merge into new cluster
			  {
					  for (q=0;q<Q;q++)
				{
						if (clust[q] == k2[r])
				  {
						  clust[q] = k1[r]; count[k1[r]]++; count[k2[r]]--;
				  }
				}
			  }
			}
			minp = -1;			//elimp() will set minp = 0 automatically in this case 
			elimps();			//  so that only empty clusters will be eliminatged
			kmeans();			//now reassign feature vectors to cluster centers
			
			return;
		}//------------------------End of Merge Function--------------------------
		//**************************************************************************/
		//-------------------------Fuzzy Clustering Function------------------------

		public static void fuzcl()
		{
			int			n, k, kk, q;// kount = 0;
			int			bigits;
			int			kmin = 0;
			int			ii;			
			double		sumvnk, ank, Denom, var;
			double[,]   sigma2 = new double [1000,50];
			double		fxpn, d;
			double		dist, sig;
			double		aveD, minD, maxSig;
			double		varAve, mse;
			double[]    aveVec = new double [1000];			

			totalits = 0; localits = 14;
			
			for (k=0;k<K;k++)        //Initialize componentwise variances
			{
					if (count[k] > 1)
			  {
					  for (n=0;n<N;n++) sigma2[k,n] = sig2[k]/(count[k]+1.0);
			  }
			  else
			  {
					  for (n=0;n<N;n++) sigma2[k,n] = 0.2;
			  } 
			}
			lbl0:  bigits = 0;
			//- - - - - - - - - - - - - - - - -Computer MWFEVs of Clusters- - -
			while ((bigits < 1) && (localits > 0))
			{ 
				for (k=0;k<K;k++)           //For each kth cluster, k=1,...,K
				{ 
					for (n=0;n<N;n++)         //Do WFEV over each nth component
					{
						for (ii=0;ii<localits;ii++)   //Do fuzzy iterations
						{
							sumvnk = 0.0; Denom = 0.0; var = 0.0;
							sig = 2.0*sigma2[k,n];
        
							for (q=0;q<Q;q++)     //For each input vector x[q]
							{
								if (clust[q] == k)  //if it is in class q then
							  {
								  fxpn = Math.Pow((v[k,n] - x[q,n]),2);
								  if (sig > 0.0) ank = Math.Exp(-fxpn/sig);
								  else           ank = 0.0;
								  Denom              = Denom  +  ank;
								  sumvnk             = sumvnk +  ank*x[q,n];
								  var                = var    +  fxpn;
							  }
							}

							if (Denom > 0.0) v[k,n] = sumvnk/Denom;
							else             v[k,n] = sumvnk;

							if (count[k] > 0.0) sigma2[k,n] = var/count[k];
							else                sigma2[k,n] = 0.0;
						}
					} // End for n loop

					sig2[k] = 0.0;
      
					for (n=0;n<N;n++) sig2[k] = sig2[k] + sigma2[k,n];
      
					if (count[k] > 0) sig2[k] = sig2[k]/N;
				} //end for k loop

				//- - - - - - - - - - - - -Assign Features to Clusters- - - --
				for (k=0;k<K;k++) 
				{
					count[k] = 0;  //Zero out cluster counts
				}


				for (q=0;q<Q;q++)                //For each qth vector x(q)
				{
					minD = (float)999999.9;
    
					for (k=0;k<K;k++)              //and each kth cluster center
					{
						d = 0.0;
						for (n=0;n<N;n++) d = d + Math.Pow(v[k,n] - x[q,n],2);
						if (d < minD)                //find distance and assign
						{
								minD = d; kmin = k;        //x(q) to cluster by min. dist.						
						}
					} 
					clust[q] = kmin; 
					count[kmin]++;                         //Assign x(q) and update count
      			 					
				}
    
				//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
				bigits++;
			} // end while bigits loop
  
			totalits = totalits + bigits;
			if (totalits < localits) goto lbl0;
			
			/*----------Compute Validity Measures-----------------*/
			
			aveD       = 0.0;  
			varAve     = 0.0;  
			mse        = 0.0;
			minD       = (float)999999.9;
			maxSig     = (float)0.000000;
			//V          = (float)0.0;

			//Compute minimum and average of intercluster squared distances
			for (k=0;k<K-1;k++)
			{ 
				for (kk=k+1;kk<K;kk++)
				{ 
					dist = 0.0; 
					for (n=0;n<N;n++) dist = dist + Math.Pow((v[k,n]-v[kk,n]),2);
					if (dist < minD)  minD = dist;
					aveD = aveD + dist;
				}
			}
			aveD = aveD / (K*(K-1)/2);

			//Compute average and maximum of cluster variances
			for (k=0;k<K;k++)
			{
					varAve = varAve + sig2[k];
				if(sig2[k] > maxSig) maxSig = sig2[k];
			}
			varAve = varAve/K;
   
			//Compute average feature vector over all input vectors
			for (n=0;n<N;n++)
			{
					aveVec[n] = 0.0;
				for (q=0;q<Q;q++)  aveVec[n] = aveVec[n] + x[q,n];
				aveVec[n] = aveVec[n]/Q;
			}
   
			//Compute MSE of cluster centers about feature vector average
			for (n=0;n<N;n++)
			{
					for (k=0;k<K;k++) mse = mse + Math.Pow((v[k,n] - aveVec[n]),2);
			}
			mse = mse/K;			
			
			return;
		}//------------------------------End of Fuzzy Function-------------------------
		//***********************************End***************************************

	}
}
